=== debian/changelog ===
shasta (0.14.0-1) unstable; urgency=medium

  [ Michael R. Crusoe ]
  * Team upload.
  * New upstream version
  * Support the "nodoc" and "nocheck" build profiles, increasing
    cross-buildability.
  * Added patch to keep debug information.
  * d/rules: save time by not building the static library.
  * d/upstream/metadata: new upstream location
  * d/control: move docs build-deps to the architecture independent
    list.
  * Strip unusual field spacing from debian/control.
  * d/control: Needs newer SeqAn2 2.5.0+. Closes: #1125658
  * Standards-Version: 4.7.3 (routine-update)

  [ Andreas Tille ]
  * d/watch: version=5
  * Standards-Version: 4.7.2 (routine-update)
  * Compatibility for boost 1.88
    Closes: #1110602
  * Salsa CI: release: experimental

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 24 Jan 2026 17:54:34 +0100
