=== debian/control ===
Source: shasta
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Shayan Doust <hello@shayandoust.me>,
           Étienne Mollier <emollier@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-exec,
               dh-sequence-python3,
               cmake,
               patchelf,
               chrpath,
               libboost-dev,
               libboost-system-dev,
               libboost-program-options-dev,
               libboost-chrono-dev,
               libboost-serialization-dev,
               libpng-dev,
               python3-dev:native,
               libpython3-dev,
               libseqan2-dev (>= 2.5),
               libspoa-dev,
               python3-pybind11,
               libcpu-features-dev [any-amd64],
               libcereal-dev,
               libblas-dev,
               liblapack-dev
Build-Depends-Indep: python3-sphinx <!nodoc>,
                      dh-sequence-sphinxdoc <!nodoc>
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/med-team/shasta
Vcs-Git: https://salsa.debian.org/med-team/shasta.git
Homepage: https://paoloshasta.github.io/shasta/
Rules-Requires-Root: no

Package: shasta
Architecture: any-amd64 arm64
# even if one comments out the sections that forbid compilation on other archs
# one gets this error message:
# undefined reference to `__sync_bool_compare_and_swap_16'
# see src/dset64.hpp for more details
Depends: ${misc:Depends},
         ${shlibs:Depends},
         python3-shasta (= ${binary:Version}),
Description: nanopore whole genome assembly (binaries and scripts)
 De novo assembly from Oxford Nanopore reads. The goal of the Shasta long
 read assembler is to rapidly produce accurate assembled sequence using
 as input DNA reads generated by Oxford Nanopore flow cells.
 .
 Computational methods used by the Shasta assembler include:
 .
  * Using a run-length representation of the read sequence. This makes
    the assembly process more resilient to errors in homopolymer
    repeat counts, which are the most common type of errors in Oxford
    Nanopore reads.
 .
  * Using in some phases of the computation a representation of the read
    sequence based on markers, a fixed subset of short k-mers (k ≈ 10).
 .
 Shasta assembly quality is comparable or better than assembly quality
 achieved by other long read assemblers.
 .
 This package contains the executable binaries (tools) and
 accommodating scripts.

Package: python3-shasta
Architecture: any-amd64 arm64
Section: python
Depends: ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends},
         ncbi-blast+
Description: nanopore whole genome assembly (dynamic library)
 De novo assembly from Oxford Nanopore reads. The goal of the Shasta long
 read assembler is to rapidly produce accurate assembled sequence using
 as input DNA reads generated by Oxford Nanopore flow cells.
 .
 Computational methods used by the Shasta assembler include:
 .
  * Using a run-length representation of the read sequence. This makes
    the assembly process more resilient to errors in homopolymer
    repeat counts, which are the most common type of errors in Oxford
    Nanopore reads.
 .
  * Using in some phases of the computation a representation of the read
    sequence based on markers, a fixed subset of short k-mers (k ≈ 10).
 .
 Shasta assembly quality is comparable or better than assembly quality
 achieved by other long read assemblers.
 .
 This package contains the dynamic library that can be interfaced and
 imported within Python.

Package: python3-shasta-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Built-Using: ${sphinxdoc:Built-Using}
Build-Profiles: <!nodoc>
Depends: ${sphinxdoc:Depends},
         ${misc:Depends}
Recommends: shasta,
            python3-shasta
Description: nanopore whole genome assembly (documentation)
 De novo assembly from Oxford Nanopore reads. The goal of the Shasta long
 read assembler is to rapidly produce accurate assembled sequence using
 as input DNA reads generated by Oxford Nanopore flow cells.
 .
 Computational methods used by the Shasta assembler include:
 .
  * Using a run-length representation of the read sequence. This makes
    the assembly process more resilient to errors in homopolymer
    repeat counts, which are the most common type of errors in Oxford
    Nanopore reads.
 .
  * Using in some phases of the computation a representation of the read
    sequence based on markers, a fixed subset of short k-mers (k ≈ 10).
 .
 Shasta assembly quality is comparable or better than assembly quality
 achieved by other long read assemblers.
 .
 This package contains the documentation for the shasta and python3-shasta
 packages.
