=== debian/watch ===
Version: 5

Template: Github
Owner: paoloshasta
Project: shasta
